#pragma once

#include <RobotAPI/interface/aron.ice>


module armarx
{
    module armem
    {
        module query
        {

            /// Which entity snapshots to get from an entity?
            class EntityQuery
            {
            };
            sequence<EntityQuery> EntityQuerySeq;

            module entity
            {
                class All extends EntityQuery
                {
                };
                class Single extends EntityQuery
                {
                    long timestamp = -1;  // -1 for latest
                };
                class Range extends EntityQuery
                {
                    long minTimestamp = -1;  // -1 for oldest
                    long maxTimestamp = -1;  // -1 for latest
                };
                /// Get just the timestamps without data. Default values for all.
                class Timestamps extends EntityQuery
                {
                    long minTimestamp = -1;  // -1 for oldest
                    long maxTimestamp = -1;  // -1 for latest
                };
            }


            /// Which entities to get from a provider segment?
            class ProviderSegmentQuery
            {
                EntityQuerySeq entityQueries;
            };
            sequence<ProviderSegmentQuery> ProviderSegmentQuerySeq;
            module provider
            {
                class All extends ProviderSegmentQuery
                {
                };
                class Single extends ProviderSegmentQuery
                {
                    string entityName;
                };
                class Regex extends ProviderSegmentQuery
                {
                    string entityNameRegex;
                };
            }


            /// Which provider segments to get from a core segment?
            class CoreSegmentQuery
            {
                ProviderSegmentQuerySeq providerSegmentQueries;
            };
            sequence<CoreSegmentQuery> CoreSegmentQuerySeq;

            module core
            {
                class All extends CoreSegmentQuery
                {
                };
                class Single extends CoreSegmentQuery
                {
                    string providerSegmentName;
                };
                class Regex extends CoreSegmentQuery
                {
                    string providerSegmentNameRegex;
                };
            }


            /// Which core segments to get from a memory?
            class MemoryQuery
            {
                CoreSegmentQuerySeq coreSegmentQueries;
            };
            sequence<MemoryQuery> MemoryQuerySeq;

            module memory
            {
                class All extends MemoryQuery
                {
                };
                class Single extends MemoryQuery
                {
                    string coreSegmentName;
                };
                class Regex extends MemoryQuery
                {
                    string coreSegmentNameRegex;
                };
            }
        }

        interface someReadingInterface
        {
            // data::EntitySnapshotQueryResultList getEntitySnapshots(data::EntitySnapshotQueryList queries);
        };

    };
};
