#pragma once

#include <memory>

#include <RobotAPI/interface/armem/MemoryInterface.h>

#include "Commit.h"
#include "ice_conversions_templates.h"


namespace IceUtil
{
    // Define in original namespace to allow ADL.
    inline void fromIce(long ice, Time& time)
    {
        time = Time::microSeconds(ice);
    }
    inline void toIce(long& ice, const Time& time)
    {
        ice = time.toMicroSeconds();
    }
}


namespace armarx::armem
{

    // void fromIce(long ice, Time& time);
    // void toIce(long& ice, const Time& time);


    void fromIce(const data::Commit& ice, Commit& commit);
    void toIce(data::Commit& ice, const Commit& commit);

    void fromIce(const data::CommitResult& ice, CommitResult& result);
    void toIce(data::CommitResult& ice, const CommitResult& result);


    void fromIce(const data::EntityUpdate& ice, EntityUpdate& update);
    void toIce(data::EntityUpdate& ice, const EntityUpdate& update);

    void fromIce(const data::EntityUpdateResult& ice, EntityUpdateResult& result);
    void toIce(data::EntityUpdateResult& ice, const EntityUpdateResult& result);

}
