#pragma once

#include <string>


namespace armarx::armem::detail
{

    /**
     * @brief Base class of memory classes on different levels.
     */
    class MemoryLevel
    {
    public:

        virtual ~MemoryLevel();


        // Introspection

        /// Get a string version of `*this`' key.
        virtual std::string getKeyString() const = 0;

        /// Get a readable name of this level for messages, errors etc.
        virtual std::string getLevelName() const = 0;

    };

}
