#pragma once

#include <RobotAPI/interface/armem/query.h>

#include "../memory/Memory.h"
#include "../memory/ice_conversions.h"

#include "BaseQueryProcessor.h"
#include "ProviderSegmentQueryProcessor.h"



namespace armarx::armem
{

    /**
     * @brief Handles memory queries.
     */
    class CoreSegmentQueryProcessor : public BaseQueryProcessor<CoreSegment, query::CoreSegmentQuery>
    {
    public:

        using BaseQueryProcessor::process;

        void process(CoreSegment& result, const query::CoreSegmentQuery& query, const CoreSegment& coreSegment) const;

        void process(CoreSegment& result, const query::core::All& query, const CoreSegment& coreSegment) const;
        void process(CoreSegment& result, const query::core::Single& query, const CoreSegment& coreSegment) const;
        void process(CoreSegment& result, const query::core::Regex& query, const CoreSegment& coreSegment) const;


        data::CoreSegmentPtr processToIce(const query::CoreSegmentQuery& query, const CoreSegment& coreSegment) const;


    private:

        ProviderSegmentQueryProcessor providerSegmentProcessor;

    };

}
