#pragma once

#include <RobotAPI/interface/armem/query.h>

#include "../memory/Memory.h"
#include "../memory/ice_conversions.h"

#include "BaseQueryProcessor.h"


namespace armarx::armem
{

    /**
     * @brief Handles memory queries.
     */
    class EntityQueryProcessor : public BaseQueryProcessor<Entity, query::EntityQuery>
    {
    public:

        using BaseQueryProcessor::process;

        void process(Entity& result, const query::EntityQuery& query, const Entity& entity) const override;

        void process(Entity& result, const query::entity::All& query, const Entity& entity) const;
        void process(Entity& result, const query::entity::Single& query, const Entity& entity) const;
        void process(Entity& result, const query::entity::Range& query, const Entity& entity) const;
        void process(Entity& result, const query::entity::Timestamps& query, const Entity& entity) const;

        void process(Entity& result, const Time& min, const Time& max, const Entity& entity,
                     bool timestampsOnly = false) const;


        data::EntityPtr processToIce(const query::EntityQuery& query, const Entity& entity) const;

    };

}
